//---------------------------------------------------------------------------

#ifndef uTrayH
#define uTrayH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <SysUtils.hpp>
#include <DateUtils.hpp>
#include "trayicon.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TfTray:public TForm
{
  __published:                  // Composants grs par l'EDI
  TTrayIcon * TrayIcon;
  TPopupMenu *TrayMenu;
  TMenuItem *miQuit;
  TMenuItem *N1;
  TMenuItem *miPause;
  TMenuItem *miResume;
  TTimer *tmrWork;
  void __fastcall miQuitClick(TObject * Sender);
  void __fastcall miPauseClick(TObject * Sender);
  void __fastcall miResumeClick(TObject * Sender);
  void __fastcall tmrWorkTimer(TObject * Sender);
  void __fastcall FormCreate(TObject * Sender);
        void __fastcall FormDestroy(TObject *Sender);
private:                       // Dclarations de l'utilisateur
  bool CsbActive;
  bool CanRun;
  HANDLE ConfigMutex;
  HANDLE TrayMutex;
public:                        // Dclarations de l'utilisateur
    __fastcall TfTray(TComponent * Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TfTray *fTray;

//---------------------------------------------------------------------------
#endif
